Skip to content
Start here

Create a Turnstile Widget

POST/accounts/{account_id}/challenges/widgets

Lists challenge widgets.

Security
API Token

The preferred authorization scheme for interacting with the Cloudflare API. Create a token.

Example:Authorization: Bearer Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY
API Email + API Key

The previous authorization scheme for interacting with the Cloudflare API, used in conjunction with a Global API key.

Example:X-Auth-Email: user@example.com

The previous authorization scheme for interacting with the Cloudflare API. When possible, use API tokens instead of Global API keys.

Example:X-Auth-Key: 144c9defac04969c7bfad8efaa8ea194
Accepted Permissions (at least one required)
Turnstile Sites WriteAccount Settings Write
Path ParametersExpand Collapse
account_id: string

Identifier

maxLength32
Query ParametersExpand Collapse
direction: optional "asc" or "desc"

Direction to order widgets.

One of the following:
"asc"
"desc"
filter: optional string

Filter widgets by field using case-insensitive substring matching. Format: field:value

Supported fields:

  • name - Filter by widget name (e.g., filter=name:login-form)
  • sitekey - Filter by sitekey (e.g., filter=sitekey:0x4AAA)

Returns 400 Bad Request if the field is unsupported or format is invalid. An empty filter value returns all results.

order: optional "id" or "sitekey" or "name" or 2 more

Field to order widgets by.

One of the following:
"id"
"sitekey"
"name"
"created_on"
"modified_on"
page: optional number

Page number of paginated results.

minimum1
per_page: optional number

Number of items per page.

maximum1000
minimum5
Body ParametersJSONExpand Collapse
domains: array of WidgetDomain
maxLength10
mode: "non-interactive" or "invisible" or "managed"

Widget Mode

One of the following:
"non-interactive"
"invisible"
"managed"
name: string

Human readable widget name. Not unique. Cloudflare suggests that you set this to a meaningful string to make it easier to identify your widget, and where it is used.

maxLength254
minLength1
bot_fight_mode: optional boolean

If bot_fight_mode is set to true, Cloudflare issues computationally expensive challenges in response to malicious bots (ENT only).

clearance_level: optional "no_clearance" or "jschallenge" or "managed" or "interactive"

If Turnstile is embedded on a Cloudflare site and the widget should grant challenge clearance, this setting can determine the clearance level to be set

One of the following:
"no_clearance"
"jschallenge"
"managed"
"interactive"
ephemeral_id: optional boolean

Return the Ephemeral ID in /siteverify (ENT only).

offlabel: optional boolean

Do not show any Cloudflare branding on the widget (ENT only).

region: optional "world" or "china"

Region where this widget can be used. This cannot be changed after creation.

One of the following:
"world"
"china"
ReturnsExpand Collapse
errors: array of ResponseInfo { code, message, documentation_url, source }
code: number
minimum1000
message: string
documentation_url: optional string
source: optional { pointer }
pointer: optional string
messages: array of ResponseInfo { code, message, documentation_url, source }
code: number
minimum1000
message: string
documentation_url: optional string
source: optional { pointer }
pointer: optional string
success: boolean

Whether the API call was successful

result: optional Widget { bot_fight_mode, clearance_level, created_on, 9 more }

A Turnstile widget’s detailed configuration

bot_fight_mode: boolean

If bot_fight_mode is set to true, Cloudflare issues computationally expensive challenges in response to malicious bots (ENT only).

clearance_level: "no_clearance" or "jschallenge" or "managed" or "interactive"

If Turnstile is embedded on a Cloudflare site and the widget should grant challenge clearance, this setting can determine the clearance level to be set

One of the following:
"no_clearance"
"jschallenge"
"managed"
"interactive"
created_on: string

When the widget was created.

formatdate-time
domains: array of WidgetDomain
maxLength10
ephemeral_id: boolean

Return the Ephemeral ID in /siteverify (ENT only).

mode: "non-interactive" or "invisible" or "managed"

Widget Mode

One of the following:
"non-interactive"
"invisible"
"managed"
modified_on: string

When the widget was modified.

formatdate-time
name: string

Human readable widget name. Not unique. Cloudflare suggests that you set this to a meaningful string to make it easier to identify your widget, and where it is used.

maxLength254
minLength1
offlabel: boolean

Do not show any Cloudflare branding on the widget (ENT only).

region: "world" or "china"

Region where this widget can be used. This cannot be changed after creation.

One of the following:
"world"
"china"
secret: string

Secret key for this widget.

sitekey: string

Widget item identifier tag.

maxLength32
result_info: optional { count, page, per_page, total_count }
count: number

Total number of results for the requested service

page: number

Current page within paginated list of results

per_page: number

Number of results per page of results

total_count: number

Total results available without any search parameters

Create a Turnstile Widget

curl https://api.cloudflare.com/client/v4/accounts/$ACCOUNT_ID/challenges/widgets \
    -H 'Content-Type: application/json' \
    -H "Authorization: Bearer $CLOUDFLARE_API_TOKEN" \
    -d '{
          "domains": [
            "203.0.113.1",
            "cloudflare.com",
            "blog.example.com"
          ],
          "mode": "invisible",
          "name": "blog.cloudflare.com login form",
          "clearance_level": "interactive"
        }'
{
  "errors": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "success": true,
  "result": {
    "bot_fight_mode": false,
    "clearance_level": "interactive",
    "created_on": "2014-01-01T05:20:00.123123Z",
    "domains": [
      "203.0.113.1",
      "cloudflare.com",
      "blog.example.com"
    ],
    "ephemeral_id": false,
    "mode": "invisible",
    "modified_on": "2014-01-01T05:20:00.123123Z",
    "name": "blog.cloudflare.com login form",
    "offlabel": false,
    "region": "world",
    "secret": "0x4AAF00AAAABn0R22HWm098HVBjhdsYUc",
    "sitekey": "0x4AAF00AAAABn0R22HWm-YUc"
  },
  "result_info": {
    "count": 1,
    "page": 1,
    "per_page": 20,
    "total_count": 2000
  }
}
Returns Examples
{
  "errors": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "success": true,
  "result": {
    "bot_fight_mode": false,
    "clearance_level": "interactive",
    "created_on": "2014-01-01T05:20:00.123123Z",
    "domains": [
      "203.0.113.1",
      "cloudflare.com",
      "blog.example.com"
    ],
    "ephemeral_id": false,
    "mode": "invisible",
    "modified_on": "2014-01-01T05:20:00.123123Z",
    "name": "blog.cloudflare.com login form",
    "offlabel": false,
    "region": "world",
    "secret": "0x4AAF00AAAABn0R22HWm098HVBjhdsYUc",
    "sitekey": "0x4AAF00AAAABn0R22HWm-YUc"
  },
  "result_info": {
    "count": 1,
    "page": 1,
    "per_page": 20,
    "total_count": 2000
  }
}